// CocoLoco for Jamagic version 1.0
// Realized as a Jamagic 2D test
// by Giovanni@Cardona.com Jan-2001
// Beware, it gets harder as you play!
// There's a semi-implemented feature for
// multilanguage
// Not much object oriented stuff in this example

//Init Game Environment
SetAutoRefresh(OFF);
oSurface=New Surface("Coco");
stm = New System();

// Load music & samples
mymusic=New Music(0);
mysound[0]=New Sound(0);
mysound[1]=New Sound(1);

//Variable List

Var score=0;
Var lookuptable=0;
Var level=0;
Var msg=0; //Messages in language bank
Var language=0; //Default Language English = 0
Var messages=4; //Total Messages to load
Var langskip=messages+1; //Jump to other language in bank
Var t=0; //Elapsed game time lap
Var cx=0; Var cy=0; Var m=0; Var x=0;

Var KEEPALIVE=0; Var STARTLEVEL=0;

//Init Messages
	For (m=0; m < messages; m++)
	{
	msg[m]=LoadString(language*langskip+m);
	} // Next m

//Init windows element
scoreedit = New Edit (CurWindow, msg[1], 370,50, 120,18);
leveledit = New Edit (CurWindow, msg[2]+" "+level, 370,80, 120,18);
startbutton = New Button (CurWindow, msg[3], 395,150, 80,32);
startbutton.OnClick=DoClick;

///////////
//MAIN GAME
///////////

While (KEEPALIVE == 0)  //Do not quit after a level is completed
{
//Init
Var STARTLEVEL=0;
startbutton.Enable();

//
SetFillGradientColor(GetRGB(Random(255),0,0), GetRGB(Random(255),0,Random(255)));
SetFillGradientDir(TRUE);
Rectangle(0,0,350,350);

	//Wait for button
	While(STARTLEVEL == 0)
	{
	Refresh();
	} //Endwhile click button

	//Start music
	mymusic.Play();
	
Var speed=1;
Var extraspeed=0; //Extra speed for a particular sprite
Var cocomaxthrow=level; //Maximum number of cocos to throw
Var cwave=0; //Objects wave flag
Var tdcocos=0;
Var pkCoco=0; //Sprite selecter
Var pabajo=0; //Flag to verify is a wave is running
Var i=0;
Var esteCoco=0; //Holds current wave array list
Var canastahit=0; //Hold array of colliding sprites
Var dropamount=0; //How many sprites will be dropped at once
Var IsASprite=0; //Checks if the current array value contains an object
Var validsprite=1; //Check for validation of the sprite selected at random
Var cococount=0; //coco counter
Var coco=0; //Holds sprites objects array
Var tablelist=0; //An array to check the selected sprites
Var columns=8; Var rows=5;
Var canasta=0;
Var RUNONLYONCE=0; // :)

//Draw cocos (balls)
For (cy=0; cy<rows; cy++)
{
	For (cx=0; cx<columns; cx++)
	{
		cococount++;
		coco[cococount] = New Sprite (30+cx*40,30+cy*40,oSurface);
		coco[cococount].SetCollision(ON);
		tablelist[cococount]=-1;
	} // Next cx
} // Next cy

 //Draw Canasta (bat)
 canasta = New Sprite(200, 300, "Canasta");
 canasta.SetCollision(ON);

 //Required to avoid an error when reading array 0
 //This may be fixed later and not needed
 //after debugging the code
 tablelist[0]=1;
 tablelist[cococount+1]=1;

 //
 totalcocos=cococount+1;
 challenge=cococount/3;

//
HideMouseCursor();

	//Little delay before start
	t = stm.GetElapsedTime();
	While (stm.GetElapsedTime()-t < 1200)
	{
	canasta.Set(GetXMouse());
	Refresh();
	}
	
 While (cococount != 0)
 {
 t = stm.GetElapsedTime();
	//Check if last wave finished
	If (cwave == 0)
	{
	pabajo = 0;  //This generates the next wave
	} //Endif cwave

	// Mueve canasta before any other sprite
	canasta.Set(GetXMouse());
	
	// Check if Coco is falling down
	If (pabajo == 1)
	{
	
	//increment counter
		For (tdcocos=1; tdcocos<lookuptable; tdcocos++)
		{
		IsASprite=IsObject(esteCoco[tdcocos]);
		//If current var is an object (sprite)
		If (IsASprite)
		{
			i[tdcocos] += level+extraspeed[tdcocos];
				// Keep rolling down until bottom of screen
				If (i[tdcocos] < 350)
				{
				esteCoco[tdcocos].Set(,i[tdcocos]);
				
					//Is Colliding the basket?
					canastahit[tdcocos] = canasta.IsColliding(esteCoco[tdcocos]);
					If (canastahit[tdcocos])
					{
					Delete esteCoco[tdcocos];
					mysound[0].Play();
					canastahit[tdcocos]=0; extraspeed[tdcocos]=0; i[tdcocos]=0;
					cwave--;
					cococount--;
					score += 10;
					scoreedit.SetText(msg[1]+" "+score);
					} //Endif canastahit
				}
				Else
				{
				Delete esteCoco[tdcocos];
				mysound[1].Play();
				canastahit[tdcocos]=0; extraspeed[tdcocos]=0; i[tdcocos]=0;
				cwave--;
				cococount--;
				score--;
				scoreedit.SetText(msg[1]+" "+score);
				} //Endif i
		} //Endif IsASprite
		} //Next
	} //Endif pabajo

	// Choose next wave
	// turn on pabajo flag
	// get Y positions
	// Dont waste time if there's no more coco sprites
	If (cococount != 0)
	{
		If (pabajo == 0)
		{
		// Set challenging speed during the game (in 3 steps)
		// This can be compacted in the next release of
		// the Jamagic beta version
		If (challenge * 2 > cococount && RUNONLYONCE == 0 )
		{
		RUNONLYONCE=1; //I can't resist to use a MMF lingo :)
		speed++;
		cocomaxthrow++;
		} //Endif challenge
		If (challenge > cococount && RUNONLYONCE == 1)
		{
		RUNONLYONCE=2; //Did I said lingo? SHAME!
		speed++;
		cocomaxthrow++;
		} //Endif challenge

			// Choose the amount of sprites in current wave
			dropamount=Random(cocomaxthrow)+1;
			If (dropamount <= cococount)
			{
				For (lookuptable=1; lookuptable<=dropamount; lookuptable++)
				{
						While (validsprite == 1)
						{
						pkCoco = Random (totalcocos);
						validsprite = tablelist[pkCoco];
							//Drop the sprites that are not blocked
							//Only for the first two levels
							If (level < 3)
								{
								If (pkCoco<columns*rows-columns+1)
								{
									//Check if the sprite is blocked
									If (tablelist[pkCoco+columns] == -1)
									{
									validsprite = 1;
									} //Endif tablelist check
								} //Endif pkcoco row block checkings
							} //Endif level
						} //Endwhile validsprite
				esteCoco[lookuptable] = coco[pkCoco];
				esteCoco[lookuptable].MoveToFront();
				i[lookuptable] = esteCoco[lookuptable].GetY();
				tablelist[pkCoco]=1;
				extraspeed[lookuptable]=Random(speed);
				validsprite=1;
				} // Next lookuptable
		    cwave=lookuptable-1;
			pabajo = 1;
			} //Endif cococount > dropamount
		} //Endif pabajo=0 
	} //Endif cococount

//
	Refresh;
	While (stm.GetElapsedTime()-t < 10);

  } //Endwhile cococount

	//End of level stuff to do
	Delete canasta;
	mymusic.Stop();
	EraseRect();
	ShowMouseCursor();
	
	//Quit after x level
	If (level == 3)
	{
	KEEPALIVE=1;
	}

} //Endwhile KEEPALIVE


////////////////
//More functions

Function DoClick(startbutton)
{
	startbutton.Disable();
	STARTLEVEL=1;
	level++;
	leveledit.SetText(msg[2]+" "+level);
}

